﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Reflection;

using Android.App;
using Android.Content;
using Android.OS;
using Android.Runtime;
using Android.Views;
using Android.Widget;

using Com.GrapeCity.Xuni.Core;

namespace FlexGridAdaptive_Android
{
    public class Customer : Java.Lang.Object
    {
        #region ** fields
        
        static Random _rnd = new Random();
        static string[] _firstNames = "Andy|Ben|Charlie|Dan|Ed|Fred|Gil|Herb|Jack|Karl|Larry|Mark|Noah|Oprah|Paul|Quince|Rich|Steve|Ted|Ulrich|Vic|Xavier|Zeb".Split('|');
        static string[] _lastNames = "Ambers|Bishop|Cole|Danson|Evers|Frommer|Griswold|Heath|Jammers|Krause|Lehman|Myers|Neiman|Orsted|Paulson|Quaid|Richards|Stevens|Trask|Ulam".Split('|');
        static string[] _countries = "China|India|United States|Indonesia|Brazil|Pakistan|Bangladesh|Nigeria|Russia|Japan|Mexico|Philippines|Vietnam|Germany|Ethiopia|Egypt|Iran|Turkey|Congo|France|Thailand|United Kingdom|Italy|Myanmar".Split('|');
        static string[] _cities = "Beijing,Shanghai,Hong Kong,Macau,Bozhou,Chaohu,New Delhi,Mumbai,Delhi,Bangalore,Chennai,Kolkata,Washington,New York,Los Angeles,Chicago,Houston,Philadelphia,Phoenix,San Antonio,San Diego,Dallas,Jakarta,Surabaya,Bandung,Tangerang,Depok,Semarang,Palembang,South Tangerang,Brasilia,San Pablo,Rio de Janeiro,Salvador,Fortaleza,Belo Horizonte,Manaus,Curitiba,Recife,Porto Alegre,Lahore,Faisalabad,Rawalpindi,Gujranwala,Multan,Moscow,Saint Petersburg,Novosibirsk,Yekaterinburg,Nizhny Novgorod,Kazan,Chelyabinsk,Samara,Tokyo,Yokohama,Ōsaka,Nagoya,Sapporo,Kōbe,Kawasaki,Saitama,Mexico City,Guadalajara,Monterrey,Puebla,Toluca,Tijuana,León,Querétaro".Split(',');

        static string[] _emailServers = "gmail|yahoo|outlook|aol".Split('|');
        static string[] _streetNames = "Main|Broad|Grand|Panoramic|Green|Golden|Park|Fake".Split('|');
        static string[] _streetTypes = "ST|AVE|BLVD".Split('|');
        static string[] _streetOrientation = "S|N|W|E|SE|SW|NE|NW".Split('|');

        #endregion

        #region ** initialization

        public Customer()
            : this(_rnd.Next(10000))
        {
        }
        public Customer(int id)
        {
            ID = id;
            First = GetString(_firstNames);
            Last = GetString(_lastNames);
            CountryID = _rnd.Next() % _countries.Length;
            City = GetString(_cities);
            Address = GetRandomAddress();
            Email = string.Format("{0}@{1}.com", (First + Last.Substring(0, 1)).ToLower(), GetString(_emailServers));
            PostalCode = _rnd.Next(10000, 99999).ToString();
            Active = _rnd.NextDouble() >= .5;

        }

        #endregion

        #region ** object model

        public int ID
        {
            get;
            set;
        }


        public int CountryID { get; set; }

        public string City { get; set; }

        public bool Active { get; set; }

        public string First { get; set; }

        public string Last { get; set; }

        public string Address { get; set; }

        public string Email { get; set; }

        public string PostalCode { get; set; }

        public string Country
        {
            get { return _countries[CountryID]; }
        }

        #endregion

        #region ** implementation

        // ** utilities
        static string GetString(string[] arr)
        {
            return arr[_rnd.Next(arr.Length)];
        }
        static string GetName()
        {
            return string.Format("{0} {1}", GetString(_firstNames), GetString(_lastNames));
        }

        private static string GetRandomAddress()
        {
            if (_rnd.NextDouble() > 0.9)
                return string.Format("{0} {1} {2} {3}", _rnd.Next(1, 999), GetString(_streetNames), GetString(_streetTypes), GetString(_streetOrientation));
            else
                return string.Format("{0} {1} {2}", _rnd.Next(1, 999), GetString(_streetNames), GetString(_streetTypes));
        }

        // ** static list provider
        public static IList<object> GetCustomerList(int count)
        {
            var list = new List<object>();
            for (int i = 0; i < count; i++)
            {
                list.Add(new Customer(i));
            }
            return list;
        }

        // ** static value providers
        public static string[] GetCountries() { return _countries; }
        public static string[] GetFirstNames() { return _firstNames; }
        public static string[] GetLastNames() { return _lastNames; }

        #endregion
    }
}